// ausgabeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ausgabe.h"
#include "ausgabeDlg.h"

#include <clocale>
// oder
// #include <locale>
// #include <iostream>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAusgabeDlg dialog

CAusgabeDlg::CAusgabeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAusgabeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAusgabeDlg)
	m_text1 = _T("");
	m_text2 = _T("");
	m_text3 = _T("");
	m_text4 = _T("");
	m_text5 = _T("");
	m_text6 = _T("");
	m_text7 = _T("");
	m_text8 = _T("");
	m_text9 = _T("");
	m_text10 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAusgabeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAusgabeDlg)
	DDX_Text(pDX, IDC_Text1, m_text1);
	DDX_Text(pDX, IDC_Text2, m_text2);
	DDX_Text(pDX, IDC_Text3, m_text3);
	DDX_Text(pDX, IDC_Text4, m_text4);
	DDX_Text(pDX, IDC_Text5, m_text5);
	DDX_Text(pDX, IDC_Text6, m_text6);
	DDX_Text(pDX, IDC_Text7, m_text7);
	DDX_Text(pDX, IDC_Text8, m_text8);
	DDX_Text(pDX, IDC_Text9, m_text9);
	DDX_Text(pDX, IDC_Text10, m_text10);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAusgabeDlg, CDialog)
	//{{AFX_MSG_MAP(CAusgabeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Ausgabe1, OnAusgabe1)
	ON_BN_CLICKED(IDC_Ausgabe2, OnAusgabe2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAusgabeDlg message handlers

BOOL CAusgabeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    // 
    // setlocale(LC_NUMERIC, "German");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAusgabeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAusgabeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAusgabeDlg::OnAusgabe1() 
{
	Beep(1000, 333);
    m_text1 = "Beep wurde mit Beep(1000, 333) ausgegeben,\n"
        + (CString)"\251 Copyright mit \\251 (Oktal 251) ausgegeben.";
    m_text2.Format("%i %s", -27, "wurde als Zahl ausgegeben.");
    m_text3.Format("%f %s", 47.11, "wurde als Zahl ausgegeben.");
    m_text4.Format("%c %s", 'C', "wurde als Zeichen ausgegeben.");
    m_text5 = (CString)"Hallo" + " wurde als Zeichenkette ausgegeben.";

    UpdateData(false);
}

void CAusgabeDlg::OnAusgabe2() 
{
    const CString Formatstring
       = (CString) "%s%4c%4c%4c%4c\n%s%4x%4x%4x%4x\n%"
         + "s%4o%4o%4o%4o\n%s%4i%4i%4i%4i";

    setlocale(LC_NUMERIC, "German");
    // oder
    // std::cout.imbue(std::locale("Dutch"));

    m_text6.Format("%s%10.2f%s", "Scheckbetrag:", 132.456789, " EUR");
    m_text7.Format("%s%010.2f%s", "Scheckbetrag:", 132.456789, " EUR");
    m_text8.Format("%s%+10.2f%s", "Scheckbetrag:", 132.456789, " EUR");

    setlocale(LC_NUMERIC, "C");
    // oder
    // std::cout.imbue(std::locale("C"));

    m_text9.Format("%s%-10.2f%s", "Scheckbetrag:", 132.456789, " EUR");
    m_text10.Format(Formatstring,
        "Zeichen:", 0x4B, 0113, 75, 'K',
        "Hexadezimal:", 0x4B, 0113, 75, 'K',
        "Oktal:", 0x4B, 0113, 75, 'K',
        "Dezimal:", 0x4B, 0113, 75, 'K');

    UpdateData(false);
}
